function makeEnemy(id, enemy)
	if id == 1 then
		local y = math.random(90, 560)
		
		local evil = {}
		evil.x = 1300
		evil.y = y
		evil.id = id
		evil.speed = 250
		evil.health = 50
		evil.image = bikeMan
		evil.data = bikeMan_data
		
		table.insert(enemy, evil)
	end
	
	if id == 2 then
		local y = math.random(90, 560)
		
		local evil = {}
		evil.x = 1300
		evil.y = y
		evil.id = id
		evil.speed = 400
		evil.health = 80
		evil.image = carMan
		evil.data = carMan_data
		
		table.insert(enemy, evil)
	end
end

function updateEnemy(enemy, dt)
	for i,v in ipairs(enemy) do --Draws the Enemies
		if v then
			v.x = v.x - (v.speed * dt)
         
			if v.x < -200 then
				v.removeme = true
			end
		end
	end
      
	for i,v in ipairs(player.bullets) do      
		if v then
			for ii,vv in ipairs(enemy) do --Draws the Enemies
				test_x = math.floor( v.x + laser:getWidth() - vv.x )
				test_y = math.floor( v.y + laser:getHeight() - vv.y)
				if v.y + laser:getHeight() > vv.y and v.y < vv.y + vv.image:getHeight() and v.x + laser:getWidth() > vv.x and v.x < vv.x + (vv.image:getWidth() / 2) then
					if test_x < vv.image:getWidth() and test_y < vv.image:getHeight() then -- extra check
						local r, g, b, a = vv.data:getPixel(test_x, test_y)
						if a ~= 0 then
							vv.health = vv.health - 0.5
							table.remove(player.bullets, i)
							--v.removeme = true
						end
					end
				end
            
				if vv.health <= 0 then            
					vv.removeme = true
				end
			end
		end
	end
	
	for i,v in ipairs(player.gunBullets) do      
		if v then
			for ii,vv in ipairs(enemy) do --Draws the Enemies
				test_x = math.floor( v.x + bullet:getWidth() - vv.x )
				test_y = math.floor( v.y + bullet:getHeight() - vv.y)
				if v.y + bullet:getHeight() > vv.y and v.y < vv.y + vv.image:getHeight() and v.x + bullet:getWidth() > vv.x and v.x < vv.x + (vv.image:getWidth() / 2) then
					if test_x < vv.image:getWidth() and test_y < vv.image:getHeight() then -- extra check
						local r, g, b, a = vv.data:getPixel(test_x, test_y)
						if a ~= 0 then
							vv.health = vv.health - 10
							table.remove(player.gunBullets, i)
							--v.removeme = true
						end
					end
				end
            
				if vv.health <= 0 then            
					vv.removeme = true
				end
			end
		end
   end
   
   	for i = #enemy, 1, -1 do
		if enemy[i].removeme then
			table.remove(enemy, i) --Deletes enemy
			
			local prize = math.random(1,4)
					
			if prize == 2 then
				player.bulletCount = player.bulletCount + 10
			end
		end	
	end
   
	for i = #player.bullets, 1, -1 do
		if player.bullets[i].removeme then
			table.remove(player.bullets, i) --Deletes bullet
		end
	end
end