require 'libs/TLfres'
require 'libs/json'
anim8 = require 'libs/anim8'

require 'enemy'
require 'menu'
require 'resolution'

function love.load()
	love.graphics.setDefaultImageFilter("nearest","nearest")

	owl       = love.graphics.newImage("textures/owls/owl2.png")
	owlNorm   = love.graphics.newImage("textures/owls/owl2.png")
	owlRed    = love.graphics.newImage("textures/owls/owl2Red.png")
	owl_stand = love.graphics.newImage("textures/owls/owl.png")
	owl_standNorm = love.graphics.newImage("textures/owls/owl.png")
	owl_standRed = love.graphics.newImage("textures/owls/owlRed.png")
	
	street    = love.graphics.newImage("textures/background.png")
	laser     = love.graphics.newImage("textures/laser.png")
	
	bikeMan   = love.graphics.newImage("textures/enemies/bike.png")
	bikeMan_data   = love.image.newImageData("textures/enemies/bike.png")
	carMan    = love.graphics.newImage("textures/enemies/car.png")
	carMan_data    = love.image.newImageData("textures/enemies/car.png")
	
	pistol    = love.graphics.newImage("textures/guns/pistol.png")
	ak47      = love.graphics.newImage("textures/guns/ak47.png")
	bullet    = love.graphics.newImage("textures/guns/bullet.png")
	
	local anim_grid = anim8.newGrid(128, 128, owl:getWidth(), owl:getHeight())
	anim_Owl = anim8.newAnimation('loop', anim_grid('1-2,1'), 0.1)
	anim_Owl_Stand = anim8.newAnimation('loop', anim_grid('1-2,1'), 1)
	
	local anim_grid = anim8.newGrid(96, 102, bikeMan:getWidth(), bikeMan:getHeight())
	anim_Bike = anim8.newAnimation('loop', anim_grid('1-2,1'), 0.1)
	
	local anim_grid = anim8.newGrid(192, 96, carMan:getWidth(), carMan:getHeight())
	anim_Car = anim8.newAnimation('loop', anim_grid('1-2,1'), 0.08)
	
	player = {
		x = 4,
		y = 128,
		speed = 220,
		bullets = {},
		health = 100,
		laser = 20,
		gunBullets = {},
		bulletCount = 100,
		currentGun = ak47,
	}
	
	gamestate = "game" --Avaliable Gamestates: Menu, Game, Store
	enemy = {}
	remEnemy = {}
	enemyTimer = 0
	bulletTimer = 0
	
	loadResolution()
	loadMenu()
end

function love.update(dt)
	if gamestate == "game" then
		if love.keyboard.isDown("up") and (not love.keyboard.isDown("x") or player.laser <= 0) then
			if player.y >= 42 then
				player.y = player.y - (player.speed * dt)
			end
		elseif love.keyboard.isDown("down") and (not love.keyboard.isDown("x") or player.laser <= 0) then
			if player.y + owl:getHeight() <= 678 then
				player.y = player.y + (player.speed * dt)
			end
		end
	
		anim_Owl:update(dt)   
		anim_Owl_Stand:update(dt)
		anim_Bike:update(dt)
		anim_Car:update(dt)
	
		if love.keyboard.isDown("x") and (love.keyboard.isDown("up") or love.keyboard.isDown("down")) then
			owl = owlRed
		elseif owl == owlRed then
			owl = owlNorm
		end
	
		if love.keyboard.isDown("x") and not (love.keyboard.isDown("up") or love.keyboard.isDown("down")) then
			owl_stand = owl_standRed
		else
			if owl_stand == owl_standRed then
				owl_stand = owl_standNorm
			end
		end
	
		if love.keyboard.isDown("x") then
			if player.laser > 0 then
				shoot()
				player.laser = player.laser - 0.05
			end
		elseif player.laser <= 20 then
			player.laser = player.laser + 0.005
		end
	
		if love.keyboard.isDown("z") and player.currentGun == ak47 and bulletTimer >= 1 then
			shootGun()
			bulletTimer = 0
		else
			bulletTimer = bulletTimer + (5 * dt)
		end
	
		updateEnemy(enemy, dt)
	
		if enemyTimer >= 2.5 then
			local typeEnemy = math.random(1,2)
			makeEnemy(typeEnemy, enemy)
			enemyTimer = 0
		else
			enemyTimer = enemyTimer + (1 * dt)
		end
	
		local remShot = {} --The Bullet Processes
		for i,v in ipairs(player.bullets) do
			v.x = v.x + dt * 600 --Moves the bullets
			
			if v.x > 1290 then
				table.insert(remShot, i) --Inserts bullets for deletion
			end
		end
	
		for i,v in ipairs(remShot) do
			table.remove(player.bullets, v) --Delets bullets
		end
	
		local remShot = {} --The Bullet Processes
		for i,v in ipairs(player.gunBullets) do
			v.x = v.x + dt * 700 --Moves the bullets
			
			if v.x > 1290 then
			table.insert(remShot, i) --Inserts bullets for deletion
			end
		end
	
		for i,v in ipairs(remShot) do
			table.remove(player.gunBullets, v) --Delets bullets
		end
	end
	
	if gamestate == "menu" then
		updateMenu()
	end
end

function love.draw()
	TLfres.transform()
	
	if gamestate == "game" then
		love.graphics.draw(street, 0, 0)
	
		if love.keyboard.isDown("up") or love.keyboard.isDown("down") then
			anim_Owl:draw(owl, player.x, player.y)
		else
			anim_Owl_Stand:draw(owl_stand, player.x, player.y)
		end
	
		if player.currentGun == pistol then
			love.graphics.draw(player.currentGun, player.x + 61, player.y + 66)
		elseif player.currentGun == ak47 then
			love.graphics.draw(player.currentGun, player.x + 11, player.y + 74)
		end
		
		for i,v in ipairs(player.bullets) do --Draws the bullets
			love.graphics.draw(laser, v.x, v.y)
		end
		
		for i,v in ipairs(player.gunBullets) do --Draws the bullets
			love.graphics.draw(bullet, v.x, v.y)
		end
	
		for i,v in ipairs(enemy) do --Draws the Enemies
			if v.id == 1 then
				anim_Bike:draw(bikeMan, v.x, v.y)
			end
			if v.id == 2 then
				anim_Car:draw(carMan, v.x, v.y)
			end
		end
	
		--Debug Stats
		love.graphics.print("Laser:"..player.laser, 0, 0)
		love.graphics.print("FPS:"..love.timer.getFPS(), 200, 0)
		love.graphics.print("Bullets:"..player.bulletCount, 400, 0)
	end
	
	if gamestate == "menu" then
		drawMenu()
	end
end

function love.keypressed(key)
	if key == '1' then
		resolution = 1
		updateResolution(resolution, ctrl)
	elseif key == '2' then
		resolution = 2
		updateResolution(resolution, ctrl)
	elseif key == '3' then
		resolution = 3
		updateResolution(resolution, ctrl)
	end
	
	if gamestate == "game" then
		if key == 'z' and player.currentGun == pistol then
			shootGun()
		end
	end
end

function shootGun()
	if player.bulletCount >= 1 then
		if player.currentGun == pistol then
			local shot = {} --Makes a bullet
			shot.x = player.x + 61 + 32
			shot.y = player.y + 66 + 2
		
			table.insert(player.gunBullets, shot)
		elseif player.currentGun == ak47 then
			local shot = {} --Makes a bullet
			shot.x = player.x + 11 + 105
			shot.y = player.y + 74 + 0
		
			table.insert(player.gunBullets, shot)
		end
		
		player.bulletCount = player.bulletCount - 1
	end
end

function shoot()
	local shot = {} --Makes a bullet
	shot.x = player.x + 88
	shot.y = player.y + 56
	
	table.insert(player.bullets, shot)
end