function loadMenu()
	menuBG         = love.graphics.newImage("textures/menu/MenuBG.png")
	startButton    = love.graphics.newImage("textures/menu/startButton.png")
	creditsButton  = love.graphics.newImage("textures/menu/creditsButton.png")
	optionsButton  = love.graphics.newImage("textures/menu/optionsButton.png")
	quitButton     = love.graphics.newImage("textures/menu/quitButton.png")

	buttons = {}
	
	addButton("game", 128, 256, startButton)
	addButton("options", 128, 416, optionsButton)
	addButton("credits", 416, 256, creditsButton)
	addButton("quit", 416, 416, quitButton)
end

function drawMenu()
	love.graphics.draw(menuBG, 0, 0)
	for i,v in ipairs(buttons) do
		if v then
			if v.color == 1 then
				love.graphics.setColor(255, 255, 0)
			else
				love.graphics.setColor(255, 255, 255)
			end
			
			love.graphics.draw(v.pic, v.x, v.y)
		end
	end
	love.graphics.setColor(255, 255, 255)
end

function updateMenu()
	local x, y = love.mouse.getPosition() -- get the position of the mouse
	
	for i,v in ipairs(buttons) do
		if v then
			if y > v.y and y < v.y + v.pic:getHeight() and x > v.x and x < v.x + v.pic:getWidth() then
				v.color = 1
			else
				v.color = 0
			end
		end
	end
end

function addButton(id, x, y, pic)
	if id == "game" then
		local button = {}
		button.pic = pic
		button.x   = x
		button.y   = y
		button.id  = id
		button.color  = 0
		
		table.insert(buttons, button)
	end
	
	if id == "credits" then
		local button = {}
		button.pic = pic
		button.x   = x
		button.y   = y
		button.id  = id
		button.color  = 0
		
		table.insert(buttons, button)
	end
	
	if id == "options" then
		local button = {}
		button.pic = pic
		button.x   = x
		button.y   = y
		button.id  = id
		button.color  = 0
		
		table.insert(buttons, button)
	end
	
	if id == "quit" then
		local button = {}
		button.pic = pic
		button.x   = x
		button.y   = y
		button.id  = id
		button.color  = 0
		
		table.insert(buttons, button)
	end
end