function loadResolution()
	if not love.filesystem.exists("settings.owl") then
		ctrl = {
			WindowWidth =  1280,
			WindowHeight = 720,
			FullScreen = false,
			Vsync = false,
		}
		
		love.filesystem.newFile("settings.owl")
		love.filesystem.write("settings.owl", json.encode(ctrl))
	else
		ctrl = json.decode(love.filesystem.read("settings.owl"))
	end
	
	TLfres.setScreen({w=ctrl.WindowWidth, h=ctrl.WindowHeight, full=ctrl.FullScreen, vsync=ctrl.Vsync}, 1280, false, true)
end

function updateResolution(resolution, ctrl)
	if resolution == 1 then --720p
		ctrl.WindowWidth = 1280
		ctrl.WindowHeight = 720
	elseif resolution == 2 then --1080p
		ctrl.WindowWidth = 1980
		ctrl.WindowHeight = 1080
	elseif resolution == 3 then --360p
		ctrl.WindowWidth = 640
		ctrl.WindowHeight = 360
	end

	TLfres.setScreen({w=ctrl.WindowWidth, h=ctrl.WindowHeight, full=ctrl.FullScreen, vsync=ctrl.Vsync}, 1280, false, true)
	love.filesystem.write("settings.owl", json.encode(ctrl))
end